import type { ExecutionResult } from 'graphql';
import { type DocumentNode, type GraphQLSchema } from 'graphql';
import type { Variables } from '../lib/graphql.js';
import type { Object$2 } from '../Schema/__.js';
import { Schema } from '../Schema/__.js';
import type { ApplyInputDefaults, OptionsInputDefaults, ReturnModeType } from './Config.js';
import type { DocumentFn } from './document.js';
import type { GetRootTypeMethods } from './RootTypeMethods.js';
import type { GraphQLObjectSelection } from './SelectionSet/toGraphQLDocumentString.js';
export type Client<$Index extends Schema.Index, $Config extends OptionsInputDefaults> = {
    raw: (document: string | DocumentNode, variables?: Variables, operationName?: string) => Promise<ExecutionResult>;
    document: DocumentFn<$Config, $Index>;
} & GetRootTypeMethods<$Config, $Index>;
interface HookInputDocumentEncode {
    rootIndex: Object$2;
    documentObject: GraphQLObjectSelection;
}
interface Input {
    /**
     * @defaultValue 'default'
     */
    name?: keyof NamedSchemas;
    schema: URL | string | GraphQLSchema;
    headers?: HeadersInit;
    /**
     * Used internally for several functions.
     *
     * When custom scalars are being used, this runtime schema is used to
     * encode/decode them before/after your application sends/receives them.
     *
     * When using root type field methods, this runtime schema is used to assist how arguments on scalars versus objects
     * are constructed into the sent GraphQL document.
     */
    schemaIndex: Schema.Index;
    returnMode?: ReturnModeType;
    hooks?: {
        documentEncode: (input: HookInputDocumentEncode, fn: (input: HookInputDocumentEncode) => GraphQLObjectSelection) => GraphQLObjectSelection;
    };
}
export declare const create: <$Input extends Input>(input: $Input) => Client<(undefined extends $Input['name'] ? NamedSchemas['default']['index'] : NamedSchemas[$Input['name']]['index']), ApplyInputDefaults<{
    returnMode: $Input['returnMode'];
}>>;
export {};
//# sourceMappingURL=client.d.ts.map